#include <qthing>

#include "esp_log.h"
#include "driver/gpio.h"

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"


#include "CyanLight.hpp"


// ### LIBS FOR TESTING ###
#include <cstdlib>
//#include "SpiderLib/SNTP.hpp"
// #include "SpiderLib/Util.hpp"
#include "SiliconTorch/CyanBusCRC.hpp"
#include "SiliconTorch/CyanBus.hpp"

#include "SiliconTorch/FxCyanRGB8.hpp"

// ###     END LIBS     ###



SiliconTorch::CyanBus::CyanBus* cyanBus = NULL;

SiliconTorch::FxCyanRGB8::FxCyanRGB8* cyanRGB = NULL;

CyanLight::CyanLightControl* ctrl;

#include "driver/gpio.h"
#include <memory>
void device_main() {

  qthing::Config cfg;

  // Needed for packet parsing, animation rendering and stuff
  qthing::power_managment_max_power();



  cyanBus = new SiliconTorch::CyanBus::CyanBus(13, 14, 12, 15, 2000000);  // Pinout of CyanStripe


  auto led0 = cfg.add<qthing::leds::WS2812B_V3>(GPIO_NUM_27, 8);

  cyanRGB = new SiliconTorch::FxCyanRGB8::FxCyanRGB8(8);
  cyanRGB->registerUDPHandler();

  auto bullshitPtr = std::shared_ptr<qthing::Animation<qthing::RGB>>(cyanRGB, [](void*){});
  cfg.add<qthing::Animator<qthing::RGBW8>>(led0)->setAnimation(bullshitPtr);







  cyanBus->packetCallback += [](const SiliconTorch::CyanBus::PacketData& data) {
    ESP_LOGW("PacketDataTestCallback", "|buffer|[ %d ]   buffer[ %s ]", data.length, data.buffer);
  };

  cyanBus->metricsCallback += [](const SiliconTorch::CyanBus::PacketMetrics& metrics) {
    ESP_LOGW("PacketMetricsTestCallback", "|buffer|[ %d ]   crc⏻[ %s ]", metrics.payloadLEN, metrics.crcOK ? "✔" : "✘");  // TODO: better use ✅ / ❌  ??
  };


  // TODO: ???


  qthing::enable_wifi();
  cfg.apply();

  return;

  
  

  ctrl = new CyanLight::CyanLightControl(3);
  //ctrl->addChannel(16);
  //ctrl->addChannel(17);
  
  ctrl->setFrqRes(100, 19);


  for (uint8_t i = 0; i < 100; i++) {

    bool _f = i % 2 == 0;

    ctrl->setPWM(0,  _f      * 1.0f);
    ctrl->setPWM(2, (_f ^ 1) * 1.0f);

    vTaskDelay(50 / portTICK_PERIOD_MS);
  }


  ctrl->setPWM(0, 0.0f);
  ctrl->setPWM(1, 0.0f);
  ctrl->setPWM(2, 1.0f);


  qthing::enable_wifi();
  return;



  auto delay = 10 / portTICK_PERIOD_MS;
  float limit = 50.0f;

  while (true) {
    for (uint8_t i = 0; i < limit; i++) {
      float pwm = i / limit;
      ctrl->setPWM(0, pwm*pwm);
      vTaskDelay(delay);
    }

    for (uint8_t i = 0; i < limit; i++) {
      float pwm = i / limit;
      ctrl->setPWM(0, 1.0f - pwm*pwm);
      vTaskDelay(delay);
    }
  }
}
